 /*
 +---------------------------------------------------------------------------+
 | Facebook Microsoft Vista Sidebar Gadget                                   |
 +---------------------------------------------------------------------------+
 | Copyright (c) 2007 Facebook, Inc.                                         |
 | All rights reserved.                                                      |
 |                                                                           |
 | Redistribution and use in source and binary forms, with or without        |
 | modification, are permitted provided that the following conditions        |
 | are met:                                                                  |
 |                                                                           |
 | 1. Redistributions of source code must retain the above copyright         |
 |    notice, this list of conditions and the following disclaimer.          |
 | 2. Redistributions in binary form must reproduce the above copyright      |
 |    notice, this list of conditions and the following disclaimer in the    |
 |    documentation and/or other materials provided with the distribution.   |
 |                                                                           |
 | THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR      |
 | IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES |
 | OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.   |
 | IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,          |
 | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  |
 | NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
 | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY     |
 | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT       |
 | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF  |
 | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.         |
 +---------------------------------------------------------------------------+
 | Developer: Amine Nebri - facebook id anebri@yahoo.com                     |
 +---------------------------------------------------------------------------+
*/

/*
Amine Nebri USA (3:34:14 PM): I have a quick question for you
Amine Nebri USA (3:35:18 PM): how do I build the url that takes me straight to the uploadphotoalbum. It has an aid that seems different it'sa much smaller number
facebookslee (3:36:59 PM): there should be a url to the album page in photos.getAlbums()
facebookslee (3:37:31 PM): the AID in the API is actually a combined facebook aid and user id
Amine Nebri USA (3:37:33 PM): I have the album id and I know how to build the url
facebookslee (3:37:50 PM): you need to break apart the upper 32 bits and lower 32 bits of the API album id
Amine Nebri USA (3:37:51 PM): but you guys are applying some transformation
facebookslee (3:37:55 PM): yep
Amine Nebri USA (3:37:58 PM): ahaaaaaaaaaaaah
Amine Nebri USA (3:38:10 PM): is that documented online?
facebookslee (3:38:17 PM): no... i don't know that it's documented
facebookslee (3:38:20 PM): you can use that procedure
Amine Nebri USA (3:38:26 PM): ok
facebookslee (3:38:29 PM): or use the album url in the album object
facebookslee (3:39:07 PM): you want $aid & 0xFFFFFFFF
facebookslee (3:39:12 PM): for the aid in the url
Amine Nebri USA (3:39:20 PM): so use the aid from the photo.album and get the url from photo.getAlbums or just breah apart the 32 bits....
facebookslee (3:39:21 PM): and $aid >> 32 for the id in the url
facebookslee (3:39:28 PM): right, either way
Amine Nebri USA (3:40:15 PM): looks like the transformation is much faster assuming it's ok to do it in javascript which will be visible to all users who download the gadget
Amine Nebri USA (3:40:34 PM): since it will be done in the javascript
*/
function copyBookmarklet()
{
    Manager.copyBookmarklet();
   
   var aid = 2217284326918194189; //2802531624531531082; //;
   var uid = 516251737; //652515242; //;
   
   var a = aid >> 64;
   var b = aid & parseInt("0xFFFFFFFFFFFFFFFF");
   var c = uid >> 64;
   var d = uid & parseInt("0xFFFFFFFFFFFFFFFF"); //5632-5450=182
   
   Util.log("aid >> 32="+a);
   Util.log("aid & parseInt(\"0xFFFFFFFF\")="+b);
   Util.log("uid >> 32="+c);
   Util.log("uis & parseInt(\"0xFFFFFFFF\")="+d);
}

/*
[
 {"pid":43812454614380972,"aid":43812454582466839,"owner":10200882,"src":"http:\/\/photos-900.ak.facebook.com\/ip002\/v65\/34\/70\/10200882\/s10200882_34025900_4799.jpg","src_big":"http:\/\/photos-900.ak.facebook.com\/ip002\/v65\/34\/70\/10200882\/n10200882_34025900_4799.jpg","src_small":"http:\/\/photos-900.ak.facebook.com\/ip002\/v65\/34\/70\/10200882\/t10200882_34025900_4799.jpg","link":"http:\/\/www.facebook.com\/photo.php?pid=34025900&id=10200882","caption":"Windows \"removing value\" from the meeting by blue screening (on a Mac)","created":"1173299264"},
 {"pid":43812454614380838,"aid":43812454582466839,"owner":10200882,"src":"http:\/\/photos-766.ak.facebook.com\/ip002\/v65\/34\/70\/10200882\/s10200882_34025766_4082.jpg","src_big":"http:\/\/photos-766.ak.facebook.com\/ip002\/v65\/34\/70\/10200882\/n10200882_34025766_4082.jpg","src_small":"http:\/\/photos-766.ak.facebook.com\/ip002\/v65\/34\/70\/10200882\/t10200882_34025766_4082.jpg","link":"http:\/\/www.facebook.com\/photo.php?pid=34025766&id=10200882","caption":"Fisch \"adding value\" to the meeting","created":"1173298544"},
 {"pid":2802531624531600403,"aid":2802531624531529421,"owner":652515242,"src":"http:\/\/photos-771.ak.facebook.com\/ip002\/v65\/2\/13\/652515242\/s652515242_74771_3933.jpg","src_big":"http:\/\/photos-771.ak.facebook.com\/ip002\/v65\/2\/13\/652515242\/n652515242_74771_3933.jpg","src_small":"http:\/\/photos-771.ak.facebook.com\/ip002\/v65\/2\/13\/652515242\/t652515242_74771_3933.jpg","link":"http:\/\/www.facebook.com\/photo.php?pid=74771&id=652515242","caption":"Harvest Meltdown - Evergreen Lodge - 2005","created":"1171437193"},
 {"pid":2217284326918214824,"aid":2217284326918194128,"owner":516251737,"src":"http:\/\/photos-672.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/s516251737_21672_4839.jpg","src_big":"http:\/\/photos-672.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/n516251737_21672_4839.jpg","src_small":"http:\/\/photos-672.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/t516251737_21672_4839.jpg","link":"http:\/\/www.facebook.com\/photo.php?pid=21672&id=516251737","caption":"fly","created":"1171825944"},
 {"pid":2217284326918214805,"aid":2217284326918194127,"owner":516251737,"src":"http:\/\/photos-653.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/s516251737_21653_3413.jpg","src_big":"http:\/\/photos-653.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/n516251737_21653_3413.jpg","src_small":"http:\/\/photos-653.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/t516251737_21653_3413.jpg","link":"http:\/\/www.facebook.com\/photo.php?pid=21653&id=516251737","caption":"","created":"1171823263"},
 {"pid":2217284326918214806,"aid":2217284326918194127,"owner":516251737,"src":"http:\/\/photos-654.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/s516251737_21654_3801.jpg","src_big":"http:\/\/photos-654.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/n516251737_21654_3801.jpg","src_small":"http:\/\/photos-654.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/t516251737_21654_3801.jpg","link":"http:\/\/www.facebook.com\/photo.php?pid=21654&id=516251737","caption":"","created":"1171823263"},
 {"pid":2217284326918214807,"aid":2217284326918194127,"owner":516251737,"src":"http:\/\/photos-655.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/s516251737_21655_4150.jpg","src_big":"http:\/\/photos-655.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/n516251737_21655_4150.jpg","src_small":"http:\/\/photos-655.ak.facebook.com\/ip002\/v65\/246\/98\/516251737\/t516251737_21655_4150.jpg","link":"http:\/\/www.facebook.com\/photo.php?pid=21655&id=516251737","caption":"","created":"1171823264"}
]
*/
function getNotification()
{
    Util.log("poke notification="+FacebookAPI.getNotification().stringValue());
}

function getLoggedInUserId()
{
    Util.log("getLoggedInUserId uid="+FacebookAPI.getLoggedInUserId());
}

function uploadPhotos()
{     
    try
    {
        var item = System.Shell.chooseFile(true, "All Files:*.*:GIF Images:*.gif:PNG Images:*.png:JPEG Files:*.jpg::", "", "");
        
        if (item == undefined)
            return;

        var file = new PhotoUploadItem(item.path, item.name, item.type, item.size).eval();
        FacebookAPI.uploadPhotoItem(file);
        Util.log("post upload file="+file.stringValue());
    }
    catch (ex)
    {
        Util.error("core.js uploadPhotos", ex);
    }
}
